//
//    Title: framewk.h
//  Created: Tue Oct 16 09:53:43 2001
//   Author: Tim Weyrich <weyrich@inf.ethz.ch>
//
//  copyright (c) 2001--2003, Computer Graphics Laboratory, ETH Zuerich
//

#ifndef __FRAMEWK_H__
#define __FRAMEWK_H__

#include <assert.h>

#include <GL/glut.h>

#include <imagegray.h>
#include <imagergba.h>

///////////////////////////////////////////////////////////////////////////////
// the following functions must be supported by painter.cc
//

//! Keyboard callback-function.
extern void  keyboardCB(unsigned char key, float x, float y);

//! Special-key keyboard callback-function.
extern void  specialCB(int key, float x, float y);

//! Mouse button callback-function.
extern void  mouseCB(int button, int state, float x, float y);

//! Mouse motion callback-function.
extern void  motionCB(float x, float y);

//! Idle callback-function.
extern void  idleCB(void);


///////////////////////////////////////////////////////////////////////////////
// the following functions are exported by libframewk.a
//


//! Initializes the exercise framework.
extern void  fwkInit(int *argc, const char *argv[]);

//! Starts the application main-loop.
extern void  fwkMainLoop(void);


//! Sets the currently displayed image.
extern void  fwkSetDisplayImage(const void *img);

//! Gets the current zoom factor.
extern float fwkGetDisplayZoom(void);

//! Sets the current zoom factor.
extern void  fwkSetDisplayZoom(float zoom);


//! Requests a redraw of the displayed image.
extern void  fwkPostRedisplay(void);

///////////////////////////////////////////////////////////////////////////////

#endif
